#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cstdint>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <bitset>
#include <unistd.h>
#include <chrono>
#include <stdio.h>
#include <utility>
#include <queue>
#include <iterator>
#include <climits>
#include <stack>
#include <algorithm>
#include <omp.h>
#include <cmath>

using namespace std;

#define CALC_TIME 1
//#define DIAGRAM_ENABLE 1
//#define ENUM_ENABLE 1


typedef uint64_t my_uint;
typedef int my_vec;

//#define SET_VEC

typedef long long int int64; // 64ビット整数型

#define LEFT 0
#define RIGHT 1

extern "C" {
extern void dgeev_( char* jobvl, char* jobvr, int* n, double* a,
                int* lda, double* wr, double* wi, double* vl, int* ldvl,
                double* vr, int* ldvr, double* work, int* lwork, int* info );
};

class Node{
public:
	char label;
	int left;
	int right;
	vector<my_vec> D;
	vector<my_vec> U;
	vector<my_vec> F;
};

struct Edge {
public:
	int src;  // 辺の始点
	int dest; // 辺の終点
	int idx;  // インデックス
	Edge(){
		src=dest=idx=0;
	}
	Edge(int src_a, int dest_a)
	{
		src = src_a;
		dest = dest_a;
		idx = 0;
	}
	Edge(int src_, int dest_, int idx_){
		src = src_;
		dest = dest_;
		idx = idx_;
	}
	inline bool operator==(const Edge& edge) const
	{
		return src == edge.src && dest == edge.dest;
	}	
	inline bool operator<(const Edge& edge) const
	{
		if(src==edge.src)
			return dest < edge.dest;
		return src < edge.src;
	}	
};

class State{
public:
	vector<Node> vnodes;
	vector<Edge> edges;
	int max_vertex;
	int start,end;
	int all;
	int length;
	State(){
		start=0; end=0; all=0;
	}
};

int OneTerminal = 0;

#if 0
inline void hash_combine(size_t& seed, size_t value) {
    seed ^= value + 0x9e3779b9 + (seed<<6) + (seed>>2);
}
#else
inline void hash_combine(size_t& seed, size_t value) {
	seed = seed * 15284356289ll + value;						
}
#endif



class LZsdd{
public:
	vector<short> mate;//mateに対するポインタとサイズに変更
	vector<my_vec> *frontier;
	int id;   // vnodeの番号
	int edge; // leafの場合のedge番号
	vector<pair<LZsdd*,LZsdd*>> child_elem;//リンクするエレメント
    const vector<pair<LZsdd*,LZsdd*>>& get_child_elem() const { return child_elem; }
	void set_child_elem(vector<pair<LZsdd*,LZsdd*>>&& child_elem_){
		child_elem = move(child_elem_);
	}
#ifdef SET_VEC
	vector<vector<my_vec> > ans;
#endif
	inline bool operator==(const LZsdd& node) const
	{
		return id == node.id && edge == node.edge && child_elem == node.child_elem;
	}	
	inline bool operator<(const LZsdd& node) const
	{
		if(id==node.id){
			if(edge == node.edge){
				return child_elem < node.child_elem;
			}
			else
				return edge < node.edge;
		}
		return id < node.id;
	}	
	
	// ノードに子elementを設定
	void SetElement(pair<LZsdd *, LZsdd *> node)
	{
		LZsdd* l_hat = node.first;
		LZsdd* r_hat = node.second;
#ifdef SET_VEC
		if(l_hat->ans.size()!=0 && r_hat->ans.size()!=0){
			for(int i=0;i<l_hat->ans.size();i++){
				for(int j=0;j<r_hat->ans.size();j++){
					vector<my_vec> t=r_hat->ans[j];
					copy(l_hat->ans[i].begin(),l_hat->ans[i].end(),back_inserter(t));
					ans.emplace_back(move(t));
				}
			}
		}
		else if(l_hat->ans.size()!=0){
			copy(l_hat->ans.begin(),l_hat->ans.end(),back_inserter(ans));
		}
		else if(r_hat->ans.size()!=0){
			copy(r_hat->ans.begin(),r_hat->ans.end(),back_inserter(ans));
		}
#if 0
		//これあると時間かかる
		for(int i=0;i<ans.size();i++){
			sort(ans.begin(),ans.end());
		}
#endif		
#endif		
		child_elem.emplace_back(move(node));
	}
};



struct Hasher
{
public:
	inline size_t operator() (const LZsdd* node) const
	{
		size_t hash = 0;
		for (unsigned int j = 0; j < node->frontier->size(); ++j) { // フロンティア上の頂点についてのみ
			int v = (*node->frontier)[j];
			hash_combine(hash, node->mate[v]);
		}
		return hash;
	}
};
struct EqualFn
{
public:
	inline bool operator() (const LZsdd* node1, const LZsdd* node2) const
	{
		for (unsigned int j = 0; j < node1->frontier->size(); ++j) { // フロンティア上の頂点についてのみ比較
			int v = (*node1->frontier)[j];
			if (node1->mate[v] != node2->mate[v]) {
				return false;
			}
		}
		return true;
	}
};

typedef unordered_set <LZsdd*, Hasher, EqualFn> my_set;


struct Hasher_cmp
{
public:
	inline size_t operator() (const LZsdd* node) const
	{
		size_t hash = 0;		
        if (node->child_elem.size() == 0) {
			hash_combine(hash, node->edge);
			hash_combine(hash, node->id);
        }
		else{
			for(const auto& e : node->child_elem){
				hash_combine(hash, (size_t)e.first);
				hash_combine(hash, (size_t)e.second);
			}
		    hash_combine(hash, node->id);
        } 
        return hash;
	}
};
struct EqualFn_cmp
{
public:
	inline bool operator() (const LZsdd* node1, const LZsdd* node2) const
	{
		if(node1->id != node2->id){
			return false;
		}
		else if(node1->child_elem.size()==0){
			return node2->child_elem.size()==0 && (node1->edge == node2->edge);
		}
		else{
			return node1->child_elem == node2->child_elem;
		}
	}
};

typedef unordered_map <const LZsdd*, const LZsdd*/*, Hasher_cmp, EqualFn_cmp*/> my_cmp;
my_cmp memo_trim;

typedef unordered_set <LZsdd*, Hasher_cmp, EqualFn_cmp> my_cache;
my_cache cacheL;


//第１引数側を第２引数側にマージ．第１側は消す
static LZsdd* Merge(LZsdd* n1, LZsdd* n2){
	for(auto& p : n1->child_elem){
		n2->child_elem.emplace_back(move(p));
	}
#ifdef SET_VEC
	for(int i=0;i<n1->ans.size();i++){
		n2->ans.emplace_back(move(n1->ans[i]));
	}
#endif
	return n2;
}

#define UNION 0
#define INTERSECTION 1
#define DIFFERENCE 2
#define CHANGE 3


set<LZsdd*> memo;
map<LZsdd*, uint64_t> memo_card;
map<LZsdd*, map<int,my_uint>> memo_card_len;
map<LZsdd*, uint64_t> memo_count;
map<LZsdd*, vector<vector<int>>> memo_enum;

//ここから読み込み部分
void ReadGraph(FILE *fin, State *state){
	int n,m;
	char edge[5];
	char p;
	vector<Edge> &edges = state->edges;
	int &max_vertex = state->max_vertex;
	int ret;
	int length_;
	int start_, end_;
	edges.emplace_back(move(Edge(0,0,0)));//0をダミーに
	ret=fscanf(fin, "%c %s %d %d ", &p, edge, &n, &m);
	max_vertex = n;
	for(int i=0; i < m; i++) {
		int x, y;			
		ret=fscanf(fin, "%c %d %d ",&p, &x, &y);
		Edge edge(x-1, y-1, i+1);
		
		if (edge.src  > edge.dest) { // src < dest になるように格納
			swap(edge.src, edge.dest);
		}
		
		if (edge.src != edge.dest) { // src == dest のものは無視
			if (max_vertex < edge.dest) {
				max_vertex = edge.dest;
			}
			
			unsigned int e;
			for (e = 0; e < edges.size(); ++e) { // 重複除去
				if (edges[e].src == edge.src && edges[e].dest == edge.dest) {
					break;
				}
			}
			if (e >= edges.size()) { // 重複が見つからない
				edges.emplace_back(move(edge)); // 辺を追加
			}
		}
	}
	ret=fscanf(fin, "%c %d ", &p, &length_);
	state->length = length_;
	ret=fscanf(fin, "%c %d %d ", &p, &start_, &end_);
	if(ret != EOF){
		state->all = false;		
		state->start = start_-1; state->end = end_-1;
	}
	else{
		state->all = true;
		int s = max_vertex;
		int g = max_vertex+1;
		int ecnt = m+1;
		for(int i = 0; i < max_vertex; i++){
			edges.emplace_back(Edge(i,s,ecnt++));
		}
		for(int i = 0; i < max_vertex; i++){
			edges.emplace_back(Edge(i,g,ecnt++));
		}
		max_vertex += 2;		
		state->length = state->length + 2;
		state->start = s; state->end = g;
	}
	
}

void FrontierUp(int v, State *state){
    vector<Node> &vnodes = state->vnodes;
	if(vnodes[v].label=='L')
		return;
	else{
		int l = vnodes[v].left;
		int r = vnodes[v].right;
		FrontierUp(vnodes[v].left, state);
		FrontierUp(vnodes[v].right, state);
        set_union(vnodes[l].U.cbegin(), vnodes[l].U.cend(),
						 vnodes[r].U.cbegin(), vnodes[r].U.cend(),
						 back_inserter(vnodes[v].U));
#if 0
		printf("v=%d\n",v);
		for(int i=0;i<vnodes[v].U.size();i++){
			printf("%d ",vnodes[v].U[i]);
		}
		printf("\n");
#endif		
	}
}



void FrontierDown(int v, State *state){
	vector<Node> &vnodes = state->vnodes;
	if(vnodes[v].label=='L')
		return;
	else{
		int l = vnodes[v].left;
		int r = vnodes[v].right;

		set_union(vnodes[v].D.cbegin(), vnodes[v].D.cend(),
						 vnodes[r].U.cbegin(), vnodes[r].U.cend(),
						 back_inserter(vnodes[l].D));
		set_union(vnodes[v].D.cbegin(), vnodes[v].D.cend(),
						 vnodes[l].U.cbegin(), vnodes[l].U.cend(),
						 back_inserter(vnodes[r].D));
		
		FrontierDown(vnodes[v].left, state);
		FrontierDown(vnodes[v].right, state);
	}
}


void ReadVtree(FILE *fin, State *state){
	char dummy[16];
	int node_num;
	int n, v;
	vector<Node> &vnodes = state->vnodes;
	vector<Edge> &edges = state->edges;
	int target=-1;
	char label;
	int num, child, lchild, rchild,ret;

	//vtree読み込み
	ret=fscanf(fin, "%s %d ",dummy, &node_num);
	vnodes.resize(node_num);
	for(int i = 0; i<node_num; i++){
		ret=fscanf(fin, "%c ", &label);
		if(label == 'L'){
			ret=fscanf(fin, "%d %d ",&num, &child);
			vnodes[num].label = 'L';
			vnodes[num].left = child; vnodes[num].right = -1;
			vnodes[num].F.emplace_back(edges[child].src);
			vnodes[num].F.emplace_back(edges[child].dest);
			vnodes[num].U = vnodes[num].F;
		}
		else if(label == 'I'){
			ret=fscanf(fin, "%d %d %d ",&num, &lchild, &rchild);
			vnodes[num].label = 'I';			
			vnodes[num].left = lchild; vnodes[num].right = rchild;
		}
	}
	//get frontier set
	FrontierUp(node_num-1, state);
	FrontierDown(node_num-1, state);
    for(int i=0;i<vnodes.size();i++){
		if(vnodes[i].label!='L'){
			set_intersection(vnodes[i].U.cbegin(), vnodes[i].U.cend(),
							 vnodes[i].D.cbegin(), vnodes[i].D.cend(),
							 back_inserter(vnodes[i].F));
		}
		
	}
#if 0	
	for(int i=0;i<vnodes.size();i++){
		printf("%d {",i);
		for(int j=0;j<vnodes[i].F.size();j++){
			printf("%d ",vnodes[i].F[j]);
		}
		printf("}\n");
	}
#endif			
}

inline LZsdd* CreateRootNode_cmp(const int number_of_vertices, const int cur){
	LZsdd *node = new LZsdd;	
	node->id = cur;
	node->edge = 0;		
	node->frontier = NULL;
	return node;
}


LZsdd *LZSDD_EMPTY=NULL, *LZSDD_FALSE=NULL;
inline LZsdd* GetEmptyLZsdd(const State *state){
	LZsdd *node1 = CreateRootNode_cmp(state->max_vertex, 0);
	node1->edge = OneTerminal;
	return LZSDD_EMPTY = node1;
}


static my_uint CardDDnnf(LZsdd* decomp){
	if(memo_card.end()!=memo_card.find(decomp)){
		return memo_card[decomp];
	}
	my_uint ret=0ULL;
	vector<pair<LZsdd*, LZsdd*>> &elem = decomp->child_elem;
	//Decision Node含むElement分
	for(auto& p : elem){
		LZsdd *left = p.first;
		LZsdd *right = p.second;
		if(left == LZSDD_FALSE || right == LZSDD_FALSE){
			;
		}
		else{
			my_uint l_ret=0ULL, r_ret=0ULL;
			// 左側
			//１辺
			if(left->edge > 0){
				l_ret = 1ULL;
			}
			// pm
			else if(left->edge < 0){
				l_ret = 2ULL;
			}
			//右側辺なし
			else if(left->child_elem.size() == 0){
				l_ret = 1ULL; 
			}
			//右側に集合族
			else{
				l_ret = CardDDnnf(left);
			}
			//右側
			//１辺
			if(right->edge > 0){
				r_ret = 1ULL;
			}
			// pm
			else if(right->edge < 0){
				r_ret = 2ULL;
			}
			//右側辺なし
			else if(right->child_elem.size() == 0){
				r_ret = 1ULL; 
			}
			//右側に集合族
			else{
				r_ret = CardDDnnf(right);
			}
			//左右を畳み込み
			ret += l_ret * r_ret;
		}
	}
	return memo_card[decomp] = ret;
}

static map<int,my_uint>& CardLenDDnnf(LZsdd* decomp){
	if(memo_card_len.end()!=memo_card_len.find(decomp)){
		return memo_card_len[decomp];
	}
	map<int, my_uint> ret;
	vector<pair<LZsdd*, LZsdd*>> &elem = decomp->child_elem;
	//Decision Node含むElement分
	for(auto& p : elem){
		LZsdd *left = p.first;
		LZsdd *right = p.second;
		map<int, my_uint> lret, rret;
		if(left == LZSDD_FALSE || right == LZSDD_FALSE){
			;
		}
		else{
			// 左側
			//１辺
			if(left->edge > 0){
				lret[1] += 1;
			}
			// pm
			else if(left->edge < 0){
				lret[1] += 1;
				lret[0] += 1;
			}
			//右側辺なし
			else if(left->child_elem.size() == 0){
				lret[0] += 1;
			}
			//右側に集合族
			else{
				lret = CardLenDDnnf(left);
			}
			//右側
			//１辺
			if(right->edge > 0){
				rret[1] += 1;
			}
			// pm
			else if(right->edge < 0){
				rret[1] += 1;
				rret[1] += 1;
			}
			//右側辺なし
			else if(right->child_elem.size() == 0){
				rret[0] += 1; 
			}
			//右側に集合族
			else{
				rret = CardLenDDnnf(right);
			}
			//左右を畳み込み
			for (auto l = lret.begin(); l != lret.end(); l++){
				for (auto r = rret.begin(); r != rret.end(); r++){
					ret[l->first+r->first] += l->second*r->second;
				}
			}
		}
	}
	return memo_card_len[decomp] = ret;
}

static my_uint CardLenDDnnf1st(LZsdd *decomp, State *state){
	int length = state->length;
	map<int, my_uint> ret = CardLenDDnnf(decomp);
	my_uint ans = 0ULL, ans2 = 0ULL;
	for (auto iter = ret.begin(); iter != ret.end(); ++iter){
		if(iter->first <= length){
			ans += iter->second;
		}
	}
	for (auto iter = ret.begin(); iter != ret.end(); ++iter){
		if(iter->first <= 2){
			ans2 += iter->second;
		}
	}
	if(state->all == true){
		ans = (ans - ans2) / 2;
	}
	return ans;
}


//ノード数数える
//elementの数に変更
static my_uint CountDDnnf(LZsdd *decomp){
	if(memo_count.end()!=memo_count.find(decomp)){
		return 0ULL;//メモにあればノード数えている
	}
	my_uint ret=0ULL;
	vector<pair<LZsdd*, LZsdd*>> &elem = decomp->child_elem;
	//Decision Node含むElement分
	for(auto& p : elem){

		LZsdd *left = p.first;
		LZsdd *right = p.second;
		my_uint l_ret=0LL, r_ret=0ULL;
		// 左側
		if(left==LZSDD_FALSE || right==LZSDD_FALSE){
			;
		}
		else{	
			ret++;//Element分
			//辺
			if(left->edge != 0){
				;			
			}
			//左側辺なし
			else if(left->child_elem.size() == 0){
				;
			}
			//左側に集合族
			else{
				l_ret = CountDDnnf(left);
			}
			
			// 右側
			//辺
			if(right->edge != 0){
				;
			}
			//右側辺なし
			else if(right->child_elem.size() == 0){
				;
			}
			//右側に集合族
			else{
				r_ret = CountDDnnf(right);
			}
			//左右を合計
			ret += l_ret + r_ret;
		}
	}
	return memo_count[decomp] = ret;
}


static vector<vector<int>> EnumDDnnf(LZsdd *decomp){
	if(memo_enum.end()!=memo_enum.find(decomp)){
		return memo_enum[decomp];
	}
    vector<std::vector<int>> v;
	vector<pair<LZsdd*, LZsdd*>> &elem = decomp->child_elem;
	//Decision Node含むElement分
	if(decomp == LZSDD_FALSE){
		return vector<std::vector<int>>();
	}
	else if(elem.size()==0){
		if(decomp->edge<0){
			v.push_back(vector<int>());
			v.push_back({-decomp->edge});
		}
		else if(decomp->edge>0){
			v.push_back({decomp->edge});
		}
		else{
			v.push_back(vector<int>());
		}
	}
	else{
		
		for(auto& e : elem){
			const auto& l_v = EnumDDnnf(e.first);
			const auto& r_v = EnumDDnnf(e.second);
            for (const auto& x : l_v) {
                for (const auto& y : r_v) {
                    auto z = x;
                    z.insert(z.end(), y.begin(), y.end());
                    v.emplace_back(move(z));
                }
            }
		}
	}
	memo_enum.emplace(decomp,v);
	return v;
}

#define OFFSET 0x40

void EnumDDnnf1st(LZsdd* decomp){
	memo_enum.clear();
	vector<vector<int>> v = EnumDDnnf(decomp);
	sort(v.begin(), v.end());
	for(auto family : v){
		for(int i=0;i<family.size();i++){
			printf("%c%c",family[i]+OFFSET,(i==family.size()-1)?'\n':' ');
		}
	}
}

//解放処理
#if 0
static void deleteDDnnf(vector<my_set >*  N){
	for(auto N_i : *N){
		for (auto n_hat : N_i){
			delete n_hat;
		}
	}
}
#endif



static void ShowDDnnf(LZsdd* decomp, FILE *ofp, unordered_map<int, vector<LZsdd*>>& same_rank){
	if(memo.end()!=memo.find(decomp)){
		return;
	}
	memo.insert(decomp);
	if(same_rank.find(decomp->id) == same_rank.end()){
		same_rank.emplace(decomp->id, vector<LZsdd*>{decomp});
	}
	else{
		same_rank.at(decomp->id).push_back(decomp);
	}

	int cur = decomp->id;
	vector<pair<LZsdd*, LZsdd*>> &elem = decomp->child_elem;
	char s[128],s1[32],s2[32];

	sprintf(s, "  decision%p [label = \"%d\",style=filled,fillcolor=gray95,shape=circle,height=.3,width=.3];\n"
			, decomp, cur);
	fprintf(ofp, "%s",s);
	
	for(auto& p : elem){
		LZsdd *left = p.first;
		LZsdd *right = p.second;
		s1[0]=s2[0]=0;
		s[0]=0;
		if(left==LZSDD_FALSE){
			sprintf(s1, "&#8869;");
		}
		else if(left->edge > 0){
			sprintf(s1, "%c",left->edge + OFFSET);
		}
		else if(left->edge < 0){
			sprintf(s1, "&#177;%c",-left->edge + OFFSET);
		}
		else if(left->edge == 0 && left->child_elem.size()==0){
			sprintf(s1, "&#949;");				
		}
		
		if(right==LZSDD_FALSE){
			sprintf(s2, "&#8869;");
		}
		else if(right->edge > 0){
			sprintf(s2, "%c",right->edge + OFFSET);
		}
		else if(right->edge < 0){
			sprintf(s2, "&#177;%c",-right->edge + OFFSET);
		}
		else if(right->edge == 0 && right->child_elem.size()==0){
			sprintf(s2, "&#949;");				
		}
		
		sprintf(s, "  element%p [label = \"<L>%s|<R>%s\"];\n",&p,s1,s2);fprintf(ofp, "%s",s);					
		
		if(left!=LZSDD_FALSE && left->child_elem.size() != 0){
			s[0]=0;
			sprintf(s,"  element%p:L:c -> decision%p [arrowsize=.50,tailclip=false,arrowtail=dot,dir=both];\n",
					&p, left);fprintf(ofp, "%s",s);				
			ShowDDnnf(left, ofp, same_rank);
		}
		if(right != LZSDD_FALSE && right->child_elem.size()!= 0){
			s[0]=0;
			sprintf(s,"  element%p:R:c -> decision%p [arrowsize=.50,tailclip=false,arrowtail=dot,dir=both];\n",
					&p, right);fprintf(ofp, "%s",s);				
			ShowDDnnf(right, ofp, same_rank);
		}
		s[0]=0;	
		sprintf(s, "  decision%p -> element%p;\n"
				,decomp,&p);fprintf(ofp, "%s",s);
	}
}


static void ShowDDnnf1st(LZsdd* decomp, FILE *ofp){
	
	fprintf(ofp,
"digraph graph_name {\n"
"  graph [\n"
"    charset = \"UTF-8\",\n"
"    bgcolor = \"#EDEDED\",\n"
"    rankdir = TB,\n"
"    nodesep = 1.1,\n"
"    ranksep = 1.05\n"
"  ];\n"
"\n"
"  node ["
"	shape=record,\n"
"	fontsize=20,\n"
"	fontname=\"Times-Italic\",\n"
"	fillcolor=white,\n"
"	style=filled,\n"
"	fixedsize=true,\n"
"	height=.30,\n"
"	width=.65,\n"	
"  ];\n");
	unordered_map<int, vector<LZsdd*>> same_rank;
	ShowDDnnf(decomp, ofp, same_rank);
	for(auto rank : same_rank){
		printf("{rank = same; ");
		for(auto vec : rank.second){
			printf("decision%p; ", vec);
		}
		printf("}\n");
	}
	fprintf(ofp, "}\n");
		
}


//部分グラフ固有処理　プロトタイプ宣言

void GetDecompVec(const int v_l, const int v_r, const int v, const State *state,
				  vector<my_vec> &diff, vector<my_vec> &uni, vector<my_vec> &inter);
void LeafChild(const int v, const int e, vector<my_set>& N, const State *state);
LZsdd* DecompChild(const LZsdd* l_hat, const LZsdd* r_hat, const State* state, const int v,
					  const vector<my_vec> &diff, const vector<my_vec> &uni, const vector<my_vec> &inter, bool& endflg);
LZsdd* CreateRootNode(const int number_of_vertices, const int cur, const vector<my_vec> *frontier);


//分解フロンティア法共通処理
void RecursiveConsruct(const int v, vector<my_set>& N, const State *state){
	const int v_l = state->vnodes[v].left;
	const int v_r = state->vnodes[v].right;
#pragma omp task shared(N)
	if(state->vnodes[v_l].label=='L'){
		LeafChild(v_l, state->vnodes[v_l].left, N, state);
	}
	else{
		RecursiveConsruct(v_l, N, state);
	}
	if(state->vnodes[v_r].label=='L'){
		LeafChild(v_r, state->vnodes[v_r].left, N, state);		
	}
	else{
		RecursiveConsruct(v_r, N, state);
	}
#pragma omp taskwait

	vector<my_vec> vec1,vec2,vec3,vec4;
	GetDecompVec(v_l, v_r, v, state, vec1, vec2, vec3);
	
	for (auto n_hat : (N)[v_l]) { // レベル v の左側各ノードについての処理
		for (auto n_hat2 : (N)[v_r]) { // レベル v の右側各ノードについての処理
			//ShowState(n_hat,"left");
			//ShowState(n_hat2,"right");
			bool endflg=false;
			
			LZsdd* n_prime = DecompChild(n_hat, n_hat2, state, v, vec1, vec2, vec3, endflg);
			//ShowState(n_prime,"join");
			if(n_prime != NULL){
				pair<LZsdd*, LZsdd*> node(n_hat,n_hat2);
				n_prime->SetElement(move(node));
				//cacheL.emplace(n_prime);//キャッシュ加えた
				//成立　最後まで成立しない部分グラフもある
				if(endflg == true){
					auto itn = (N)[state->vnodes.size()-1].find(n_prime);					
					if(itn != (N)[state->vnodes.size()-1].end()){
						Merge(n_prime, *itn);
					}
					else{
						(N)[state->vnodes.size()-1].emplace(n_prime);
					}
				}
				else{
					auto itn = (N)[v].find(n_prime);
					
					if (itn != (N)[v].end()){
						//n_primeとn_primeprimeをマージ
						Merge(n_prime, *itn);
					}
					else{
						(N)[v].emplace(n_prime);
					}
				}
			}
		}
	}
}

LZsdd* make_zsdd_literal(int edge, int id, const State *state){
	LZsdd* ret = CreateRootNode_cmp(state->max_vertex, id);
	ret->edge = edge;
	auto it = cacheL.find(ret);
	if(it != cacheL.end()){
		delete ret;
		return *it;
	}
	cacheL.emplace(ret);
	return ret;
}

LZsdd* make_zsdd_decomposition(vector<pair<LZsdd*, LZsdd*>>&& child_elem, int id, const State *state){
	sort(child_elem.begin(), child_elem.end());
	LZsdd* ret = CreateRootNode_cmp(state->max_vertex, id);
	ret->set_child_elem(move(child_elem));
	auto it = cacheL.find(ret);
	if(it != cacheL.end()){
		delete ret;
		return *it;
	}
	cacheL.emplace(ret);
	return ret;
}

LZsdd* Trim(const LZsdd* zsdd, const State *state) {
	if (zsdd == LZSDD_FALSE) return LZSDD_FALSE;
	if (zsdd->child_elem.size() == 0 && zsdd->edge==0) return LZSDD_EMPTY;
    if (zsdd->child_elem.size() == 0) return const_cast<LZsdd*>(zsdd);

	auto c = memo_trim.find(zsdd);
	if (c != memo_trim.end()) {
		return const_cast<LZsdd*>(c->second);
	}

    vector<pair<LZsdd*, LZsdd*>> old_decomp = zsdd->get_child_elem(),
		new_decomp;
	new_decomp.resize(zsdd->get_child_elem().size());

	for(int i=0; i< old_decomp.size(); i++){
		new_decomp[i].first = Trim(old_decomp[i].first, state);
		new_decomp[i].second = Trim(old_decomp[i].second, state);		
	}
#if 1
	if (new_decomp.size() == 2) {
        pair<LZsdd*, LZsdd*> &e1 = new_decomp[0], &e2 = new_decomp[1];
		//全てleafか
		if(e1.first->child_elem.size() == 0 && e1.second->child_elem.size() == 0 &&
		   e2.first->child_elem.size() == 0 && e2.second->child_elem.size() == 0){
			if (e1.first->edge==0 && e1.second->edge==0) {
				if(e2.first->edge==0){
					LZsdd* node = make_zsdd_literal(-e2.second->edge, e2.second->id, state);
					new_decomp[1].second = node;
					return const_cast<LZsdd*>(e2.second);
				}
				else if(e2.second->edge==0){
					LZsdd* node = make_zsdd_literal(-e2.first->edge, e2.first->id, state);
					new_decomp[1].first = node;
					return const_cast<LZsdd*>(e2.first);
				}
			} 
			if (e2.first->edge==0 && e2.second->edge==0) {
				if(e1.first->edge==0){
					LZsdd* node = make_zsdd_literal(-e1.second->edge, e1.second->id, state);
					new_decomp[0].second = node;
					return const_cast<LZsdd*>(e1.second);
				}
				else if(e1.second->edge==0){			
					LZsdd* node = make_zsdd_literal(-e1.first->edge, e1.first->id, state);
					new_decomp[0].first = node;
					return const_cast<LZsdd*>(e1.first);
				}
			} 
		}

		
	}
#endif	
    if (new_decomp.size() == 1) {
        // zero-suppression rule
        pair<LZsdd*, LZsdd*> &e = new_decomp[0];
        if (e.first->edge==0 && e.first->child_elem.size() == 0) {
            memo_trim.emplace(zsdd, e.second);
            return const_cast<LZsdd*>(e.second);
        } 
        if (e.second->edge == 0 && e.second->child_elem.size() == 0) {
            memo_trim.emplace(zsdd, e.first);
            return const_cast<LZsdd*>(e.first);
        }
    }
    LZsdd* ret = make_zsdd_decomposition(move(new_decomp), zsdd->id, state);
	memo_trim.emplace(zsdd, ret);

    return ret;
}


void PrintLZsdd(LZsdd* node){
	printf("id %d\n", node->id);
	printf("edge %d\n", node->edge);
	printf("num %lu\n", node->child_elem.size());
	puts("------");
	for(auto p : node->child_elem){
		printf("%d %d\n", p.first->edge, p.second->edge);
		PrintLZsdd(p.first);
		PrintLZsdd(p.second);
	}
	puts("------");
}




LZsdd* Reduce(LZsdd *decomp, const State *state){
	GetEmptyLZsdd(state);//EMPTY定義
	int max_vidx = state->vnodes.size()-1;
	LZsdd * decomp2= CreateRootNode(state->max_vertex, max_vidx, (vector<my_vec>*)&state->vnodes[max_vidx].F);
	//decomp2 = Compress(decomp, state);
	decomp2 = Trim(decomp, state);
	return decomp2;
}




void Dfrontier(State* state)
{
	vector<my_set> N(state->vnodes.size());
	int max_vidx = state->vnodes.size()-1;
    auto start = std::chrono::system_clock::now();
	RecursiveConsruct(max_vidx, N, state);
	LZsdd* ans= CreateRootNode(state->max_vertex, max_vidx, (vector<my_vec>*)&state->vnodes[max_vidx].F);	
	for (auto n_hat : (N)[max_vidx]) {
		Merge(n_hat, ans);
	}
    auto end = std::chrono::system_clock::now();
    auto build_time = std::chrono::duration_cast<std::chrono::milliseconds>(end-start).count();

    start = std::chrono::system_clock::now();
	LZsdd *ansred;
	//printf("reduce\n");
	memo_card.clear(); memo_count.clear();
	ansred = Reduce(ans, state);
    end = std::chrono::system_clock::now();
    auto reduce_time = std::chrono::duration_cast<std::chrono::milliseconds>(end-start).count();
	
	//printf("count\n");
	//auto mc = CardDDnnf(ansred);
    start = std::chrono::system_clock::now();
	auto mc = CardLenDDnnf1st(ansred, state);
    end = std::chrono::system_clock::now();
    auto count_time = std::chrono::duration_cast<std::chrono::milliseconds>(end-start).count();
	
#ifdef ENUM_ENABLE
	EnumDDnnf1st(ansred);
#endif
#ifdef DIAGRAM_ENABLE
	ShowDDnnf1st(ansred, stdout);
#endif	
#ifdef CALC_TIME	
	cout << mc;
#endif
}

class NX{
#define INF 10000
	struct edge { 
		int to,cap,rev; 
		edge (int to, int cap, int rev){
			this->to=to; this->cap=cap; this->rev=rev;
		}
	};
public:
	typedef vector<edge> edges;
	vector<edges> G;
	//set<pair<int,int>> min_cut_pair;

	int V;
	vector<int> level;
	vector<int> iter;
	map<int, set<int>> gcnt;
	
	void bfs(int s){
		fill(level.begin(), level.end(), -1);
		queue<int> q;
		level[s]=0;
		q.push(s);	
		while(!q.empty()){
			int v=q.front(); q.pop();
			for(int i=0; i<G[v].size(); i++){
				edge &e = G[v][i];
				if(e.cap>0 && level[e.to]<0){
					level[e.to]=level[v]+1;
					q.push(e.to);
				}
			}
		}
	}
	
	int dfs(int v, int t, int f){
		if(v==t)
			return f;
		for(int &i = iter[v];i < G[v].size(); i++){
			edge &e = G[v][i];
			if(e.cap>0 && level[e.to]>level[v]){
				int d=dfs(e.to, t, min(f,e.cap));
				if(d>0){
					e.cap-=d;
					G[e.to][e.rev].cap+=d;
					return d;
				}
			}
		}
		return 0;
	}

	void dfs_min(int v, int t, int f, map<int, set<int>> &graph){
		if(v==t)
			return;
		for(int &i = iter[v];i < G[v].size(); i++){
			edge &e = G[v][i];
			if(e.cap>0 && level[e.to]>level[v]){
				dfs_min(e.to, t, min(f,e.cap), graph);
			}
			else{
				gcnt[v].emplace(e.to);
				//min_cut_pair.emplace(make_pair(v,e.to));
			}
		}
	}

	
	void minimum_node_cut(map<int, set<int>> &graph, set<int> &vs, int s, int t, int max_v, set<int> &min_cut){
		G.resize(max_v*2);G.clear();
		level.resize(max_v*2);
		iter.resize(max_v*2);
		V=max_v;
		for(auto v: vs){
			int v2 = v+V;
			if((v == s)||(v == t)){
				G[v].push_back(edge(v2,INF,G[v2].size()));
			}
			else{
				G[v].push_back(edge(v2,1,G[v2].size()));
			}
			G[v2].push_back(edge(v,0,G[v].size()-1));
		}
		for(auto es: graph){
			int u=es.first;
			for(auto v : es.second){
				int u2=u+V;
				int v2=v+V;
				G[u2].push_back(edge(v,INF,G[v].size()));
				G[v].push_back(edge(u2,0,G[u2].size()-1));
				G[v2].push_back(edge(u,INF,G[u].size()));
				G[u].push_back(edge(v2,0,G[v2].size()-1));
			}
		}
		int ans=0;
		while(1){
			bfs(s);
			if(level[t]<0)
				break;
			fill(iter.begin(), iter.end(), 0);
			int f;
			while((f=dfs(s,t,INF)) > 0){
				ans+=f;
			}
		}
		//printf("flow %d\n",ans);
		fill(iter.begin(), iter.end(), 0);
		dfs_min(s,t, INF, graph);
		for(int i=0;i<graph.size();i++){
			if((graph[i].size() + 1) == gcnt[i].size()){
				min_cut.emplace(i);
			}
		}
	}
};


class BranchTree{
public:
	map<int , map<int, set<int>>> septree;
	map<pair<int,int>, int> redge; //edge reverse loopkup
	int node_idx;

	//septree
	void initialize(State *state){
		map<int,set<int>> E;
		int cnt=0;
		node_idx = state->edges.size()+10;//edge={1,...}		
		for(auto e : state->edges){
			if(cnt==0){
				cnt++; continue;
			}
			set<int> M;
			M.emplace(e.src); M.emplace(e.dest);
			E[e.idx] = M;
			redge[make_pair(e.src,e.dest)]=e.idx;
			redge[make_pair(e.dest,e.src)]=e.idx;
		}

		septree[node_idx] = E;
		
	}
	int get_new_node(){
		return ++node_idx;
	}
	bool check_node_deg(){
		bool ret = true;
		for(auto b: septree){
			ret &= (b.second.size() <= 3);
		}
		return ret;
	}
    void split(int v, vector<int> &A, vector<int> &B, int &l, int &r, State *state){
		set<int> MA, MB, M;
		l = get_new_node();
		r = get_new_node();
		//printf("%s\n",__FUNCTION__);
		//printf("A\n");
		for(auto u : A){
			//printf("%d ",u);
			set<int> &sep = septree[v][u];
			if(u >= state->edges.size()+10){
				septree[l][u] = sep;
				septree[u][l] = sep;
			}
			else{
				septree[l][u] = sep;
			}
			for(auto v : sep){
				MA.emplace(v);
			}
		}
		//printf("\n");
		//printf("B\n");
		for(auto u : B){
			//printf("%d ",u);
			set<int> &sep = septree[v][u];
			if(u >= state->edges.size()+10){
				septree[r][u] = sep;								
				septree[u][r] = sep;
			}
			else{
				septree[r][u] = sep;				
			}

			for(auto v : sep){
				MB.emplace(v);
			}
		}
		//printf("\n");
		set_intersection(MA.begin(), MA.end(),
						 MB.begin(), MB.end(),
						 inserter(M, M.end()));
		septree[l][r] = M;
		septree[r][l] = M;
		septree.erase(v);

		for(auto &vs : septree){
			vs.second.erase(v);
		}
#if 0		
		printf("septree[%d]\n",l);
		for(auto v : septree[l]){
			printf("%d ",v.first);
		}
		printf("\n");
		printf("septree[%d]\n",r);
		for(auto v : septree[r]){
			printf("%d ",v.first);
		}
		printf("\n");
#endif		
	}

	/* Auxiliary routine: printing eigenvalues */
	void print_eigenvalues( char* desc, int n, double* wr, double* wi ) {
        int j;
        printf( "\n %s\n", desc );
		for( j = 0; j < n; j++ ) {
			if( wi[j] == (double)0.0 ) {
				printf( " %6.8f", wr[j] );
			} else {
				printf( " (%6.8f,%6.8f)", wr[j], wi[j] );
			}
		}
		printf( "\n" );
	}
	
	/* Auxiliary routine: printing eigenvectors */
	void print_eigenvectors( char* desc, int n, double* wi, double* v, int ldv ) {
        int i, j;
        printf( "\n %s\n", desc );
		for( i = 0; i < n; i++ ) {
			j = 0;
			while( j < n ) {
				if( wi[j] == (double)0.0 ) {
					printf( " %6.8f", v[i+j*ldv] );
					j++;
				} else {
					printf( " (%6.8f,%6.8f)", v[i+j*ldv], v[i+(j+1)*ldv] );
					printf( " (%6.8f,%6.8f)", v[i+j*ldv], -v[i+(j+1)*ldv] );
					j += 2;
				}
			}
			printf( "\n" );
		}
	}
	

	void eigen_method(set<int> &last_updated, State *state){
		//printf("%s\n",__FUNCTION__);
		last_updated.clear();
		int v;
        for(auto n : septree){
            if(n.second.size() > 3){
				v = n.first;
				break;
			}
		}
		//N_v
		map<int, set<int>> N;
		for(auto u : septree[v]){
			set<int> seps = septree[v][u.first];
			for(auto node : seps){
				N[node].emplace(u.first);
			}
		}
		vector<int> adj_graph;
		for(auto edge : septree[v]){
			adj_graph.emplace_back(edge.first);
		}
		int max_v=INT_MIN;
		for(auto e : adj_graph){
			for(auto u : septree[v][e]){
				max_v = max(max_v, u);
			}
		}
		//matrix

		vector<double> mat(adj_graph.size() * adj_graph.size());
		for(int i=0;i<adj_graph.size(); i++){
			int x = adj_graph[i];
			int cnt=0;
			for(auto s : N){
				if(s.second.count(x)>0)
					cnt++;
			}
			for(int j=i;j<adj_graph.size();j++){
				int y = adj_graph[j];
				if(i == j){
					mat[i*adj_graph.size() + i] = (double)cnt;
				}
				else{
					double sum=0.0;
					for(auto s : N){
						if(s.second.count(x) && s.second.count(y)){
							sum += -1.0/(s.second.size()-1);
						}
					}
					mat[i*adj_graph.size()+j] = sum;
					mat[j*adj_graph.size()+i] = sum;
				}
			}
		}

		//get eigen vectors
        int n = adj_graph.size(), lda = n, ldvl = n, ldvr = n, info, lwork;
        double wkopt;
        double* work;
        double wr[n], wi[n], vl[n*n], vr[n*n];
		char jobvl='N', jobvr='V';
        lwork = -1;
		//calc work size
        dgeev_( &jobvl, &jobvr, &n, mat.data(), &lda, wr, wi, vl, &ldvl, vr, &ldvr, &wkopt, &lwork, &info);
        lwork = (int)wkopt;
        work = (double*)malloc( lwork*sizeof(double) );
		//calc eigen
        dgeev_( &jobvl, &jobvr, &n, mat.data(), &lda, wr, wi, vl, &ldvl, vr, &ldvr, work, &lwork, &info );
        //print_eigenvalues( (char*)"Eigenvalues", n, wr, wi );
        //print_eigenvectors( (char*)"Left eigenvectors", n, wi, vl, ldvl );
		//print_eigenvectors( (char*)"Right eigenvectors", n, wi, vr, ldvr );		
        free( (void*)work );
		vector<pair<double,int>> tmp;
		for(int i=0; i < n; i++){
			tmp.emplace_back(make_pair(wr[i], i));
		}
		sort(tmp.begin(), tmp.end());
		vector<pair<double, int>> sorted;
		vector<int> sorted_edges;
		int second_smallest = tmp[1].second;
		for(int i=0;i<n;i++){
			sorted.emplace_back(make_pair(vr[n*second_smallest+i], adj_graph[i]));
		}
		for(int i=0; i<n; i++){
			sorted_edges.emplace_back(sorted[i].second);
		}
		sort(sorted_edges.begin(), sorted_edges.end());
		int cut_num=int(ceil(n/3.0)+0.5);
		vector<int> cut_A; copy(sorted_edges.begin(), sorted_edges.begin()+cut_num, back_inserter(cut_A) );
	    vector<int> cut_B; copy(sorted_edges.end()-cut_num, sorted_edges.end(), back_inserter(cut_B) );
		vector<int> X,Y;
		//vector<int> cut_A={5,6,7,10}, cut_B={2,3,4,8};
#if 0		
		printf("cut_A\n");
		for(auto v: cut_A){
			printf("%d ", v);
		}
		printf("\n");
		printf("cut_B\n");
		for(auto v: cut_B){
			printf("%d ", v);
		}
		printf("\n");
#endif		
		//printf("find cut start\n");
		find_cut(v, cut_A, cut_B, max_v, sorted_edges, X, Y);
		//printf("find cut end\n");
		int t1,t2;
#if 0		
		printf("sorted edges\n");
		for(auto v: sorted_edges){
			printf("%d ", v);
		}
		printf("\n");
#endif		
		split(v, X, Y, t1, t2, state);
		last_updated.emplace(t1);
		last_updated.emplace(t2);
	}

	void find_cut(int v, vector<int> &A, vector<int> &B, int max_v, vector<int> &sorted_edges, vector<int> &X_, vector<int> &Y_){
		map<int,set<int>> adj_graph;
		set<int> vs;
		set<int> cut;
		make_adj_graph(v, adj_graph, vs);
		int s = max_v+1;
		int g = max_v+2;
		//printf("s %d g %d\n",s,g);
		for(auto e : A){
			vs.emplace(s);
			set<int> seps = septree[v][e];
			for(auto v : seps){
				adj_graph[s].emplace(v);
				adj_graph[v].emplace(s);
			}
		}
		for(auto e : B){
			vs.emplace(g);
			set<int> seps = septree[v][e];
			for(auto v : seps){
				adj_graph[g].emplace(v);
				adj_graph[v].emplace(g);
			}
		}
		NX nx;
		nx.minimum_node_cut(adj_graph, vs, s, g, max_v+3, cut);//max_v includs s,t, NULL
		set<int> X;
		vector<int> Y;
		node2edge(cut, adj_graph, v, s, g, max_v, sorted_edges, X, Y);
#if 0		
		printf("cut2edge\n");
		printf("X ");
		for(auto v : X){
			printf("%d ",v);
		}
		printf("\n");
		printf("Y ");
		for(auto v : Y){
			printf("%d ",v);
		}
		printf("\n");
#endif
		vector<int> XA, YB;
		sort(A.begin(), A.end());
		sort(B.begin(), B.end());
		set_union(X.cbegin(), X.cend(),
					   A.cbegin(), A.cend(),
					   back_inserter(XA));
		set_difference(XA.cbegin(), XA.cend(),
					   B.cbegin(), B.cend(),
					   back_inserter(X_));
		set_union(Y.cbegin(), Y.cend(),
					   B.cbegin(), B.cend(),
					   back_inserter(YB));
		set_difference(YB.cbegin(), YB.cend(),
					   A.cbegin(), A.cend(),
					   back_inserter(Y_));
	}

	void node2edge(set<int> cut_nodes, map<int,set<int>> adj_graph,
							int orig_v, int s, int g, int max_v, vector<int> &sorted_edges,
							set<int> &start_edge_set, vector<int> &end_edge_set){

		stack<int> st;
		st.push(s);
		set<int> expanded;
		while(!st.empty()){
			int v = st.top(); st.pop();
			if(expanded.count(v) > 0){
				continue;
			}
			else{
				if(cut_nodes.count(v) > 0){
					continue;
				}
			}
			expanded.emplace(v);
			for(auto u : adj_graph[v]){
				st.push(u);
				auto it = redge.find(make_pair(u,v));
				if(it != redge.end()){
					auto result = find(sorted_edges.begin(), sorted_edges.end(), (*it).second);
					if(result != sorted_edges.end()){
						start_edge_set.emplace((*it).second);
					}
				}
			}
		}
		set<int> all_edges;
		for(auto edge : septree[orig_v]){
			all_edges.emplace(edge.first);
		}
		set_difference(all_edges.cbegin(), all_edges.cend(),
					   start_edge_set.cbegin(), start_edge_set.cend(),
					   back_inserter(end_edge_set));
		
	}
	
	void make_adj_graph(int v, map<int,set<int>> &adj_graph, set<int> &vs){
		vector<int> edge_attr_pairs;
		for(auto edge : septree[v]){
			edge_attr_pairs.emplace_back(edge.first);
		}
		for(auto u : edge_attr_pairs){
			vector<int> seps;
			for(auto w : septree[v][u]){
				seps.emplace_back(w);
			}
			for(int i=0; i<seps.size()-1;i++){
				for(int j=i+1; j<seps.size();j++){
					int x=seps[i];
					int y=seps[j];
					vs.emplace(x);
					vs.emplace(y);
					adj_graph[x].emplace(y);
					adj_graph[y].emplace(x);
				}
			}
		}
	}
	
    void push_method(int target_v, State *state){
		//printf("%s\n",__FUNCTION__);
		if(septree[target_v].size() < 4)
			return;
		map<int, int> sep_counter;
		for(auto e : septree[target_v]){
			for(auto u : e.second){
				sep_counter[u]++;
			}
		}
		
		vector<int> edges;
		for(auto v : septree[target_v]){
			edges.emplace_back(v.first);
		}
		bool found=false;
		vector<int> vecA, vecB;		
		for(int i = edges.size()-1; i >= 1; i--){
			for(int j = i-1; j >= 0; j--){
				set<int> intersect;
				int u = edges[i]; int v = edges[j];
				set_intersection(septree[target_v][u].begin(), septree[target_v][u].end(),
								 septree[target_v][v].begin(), septree[target_v][v].end(),
								 inserter(intersect, intersect.end()));

				//Condition in the End of 4.1.
				bool can_push = false;
				for(auto i : intersect){
					if(sep_counter[i] == 2){
						can_push = true;
						break;
					}
				}
				if(!can_push)
					continue;
				
				set<int> union_;
				
				set_union(septree[target_v][u].begin(), septree[target_v][u].end(),
						  septree[target_v][v].begin(), septree[target_v][v].end(),
						  inserter(union_, union_.end()));

				map<int, int> sep_counter_copy = sep_counter;
				for(auto i : septree[target_v][u]){
					sep_counter_copy[i]--;
				}
				for(auto i : septree[target_v][v]){
					sep_counter_copy[i]--;
				}
				set<int> remaining_sep;
				for(auto m : sep_counter_copy){
					if(m.second > 0){
						remaining_sep.insert(m.first);
					}
				}
				set<int> intersect2;
				//Lemma 1.
				set_intersection(union_.begin(), union_.end(),
								 remaining_sep.begin(), remaining_sep.end(),
								 inserter(intersect2, intersect2.end()));
				if(intersect2.size() <= max(septree[target_v][u].size(), septree[target_v][v].size())){
					found = true;
					vecA.emplace_back(u); vecA.emplace_back(v);
					break;
				}
			}
			if(found)
				break;
		}
		if(found){
			for(auto b : septree[target_v]){
				auto it = find(vecA.begin(), vecA.end(), b.first);	
				if (it == vecA.end()) {
					vecB.emplace_back(b.first);
				}
			}
			int newA, newB;
			split(target_v, vecA, vecB, newA, newB, state);
			push_method(newB, state);
		}
	}
    void safe_method(int v, State *state){
        push_method(v, state);
	}
	void decomp_graph(State *state){
		set<int> last_updated; last_updated.emplace(node_idx);
		while(1){
			if(check_node_deg())
				break;
			//printf("safe\n");
			for(auto v : last_updated){
				safe_method(v, state);
			}
			if(check_node_deg())
				break;
			//printf("eigen\n");
			eigen_method(last_updated, state);
		}
	}

	void gen_vtree(int root_node, State *state){
		vector<Node> &vnodes = state->vnodes;
		vector<Edge> &edges = state->edges;
        int vtree_root;
        int first_leaf;
		//map<int , map<int, set<int>>> septree;		
		for(auto keys : septree){
			for(auto v : keys.second){
				if(v.first <= edges.size()){
					int n = v.first;
					if(edges[n].src == root_node || edges[n].dest == root_node){
						vtree_root = keys.first;
						first_leaf = n;
					}
				}
			}
		}
        //printf("vtree %lu\n", septree.size() + edges.size());
		int node_num = septree.size() + edges.size();
		vnodes.resize(septree.size() + edges.size());
		
		int c = recursive_gen_vtree(vtree_root, first_leaf, 0, state);
		
		//printf("L %d %d\n", c, first_leaf);
        //printf("I %d %d %d\n", c+1, c, c-1);
		
		vnodes[c].label = 'L';
		vnodes[c].left = first_leaf; vnodes[c].right = -1;
		vnodes[c].F.emplace_back(edges[first_leaf].src);
		vnodes[c].F.emplace_back(edges[first_leaf].dest);
		vnodes[c].U = vnodes[c].F;		
		
		vnodes[c+1].label = 'I';			
		vnodes[c+1].left = c; vnodes[c+1].right = c-1;
		
		//get frontier set
		FrontierUp(node_num-1, state);
		FrontierDown(node_num-1, state);
		for(int i=0;i<vnodes.size();i++){
			if(vnodes[i].label!='L'){
				set_intersection(vnodes[i].U.cbegin(), vnodes[i].U.cend(),
								 vnodes[i].D.cbegin(), vnodes[i].D.cend(),
								 back_inserter(vnodes[i].F));
		}
		
	}
		
	}
    int recursive_gen_vtree(int n, int parent, int c, State *state){
		vector<Node> &vnodes = state->vnodes;
		vector<Edge> &edges = state->edges;		
		if(n <= state->edges.size()){
            //printf("L %d %d\n", c, n);
			vnodes[c].label = 'L';
			vnodes[c].left = n; vnodes[c].right = -1;
			vnodes[c].F.emplace_back(edges[n].src);
			vnodes[c].F.emplace_back(edges[n].dest);
			vnodes[c].U = vnodes[c].F;
			return c+1;
		}
		vector<int> lr;
		for(auto key : septree[n]){
			if(key.first != parent){
				lr.emplace_back(key.first);
			}
		}
        int l_c = recursive_cnt_nodes(lr[0], n, state);
        int r_c = recursive_cnt_nodes(lr[1], n, state);
        int p = lr[0];
        int s = lr[1];
        if(l_c > r_c){
            p = lr[1];
			s = lr[0];
		}
    
		int l_count = recursive_gen_vtree(p, n, c, state);
        int l_id = l_count - 1;
        int r_count = recursive_gen_vtree(s, n, l_count, state);
		int r_id = r_count - 1;
		//printf("I %d %d %d\n", r_count, l_id, r_id);
		vnodes[r_count].label = 'I';			
		vnodes[r_count].left = l_id; vnodes[r_count].right = r_id;
        return r_count + 1;
	}
    //left, right, center: post-order
    int recursive_cnt_nodes(int n, int parent, State *state){
		if(n <= state->edges.size())
            return 1;
        int count = 1;
		for(auto m : septree[n]){
            if(m.first == parent)
                continue;
            count += recursive_cnt_nodes(m.first, n, state);
		}
	    return count;
	}
};


